//+------------------------------------------------------------------+
//|                                                 Template_EA      |
//|                                        Copyright ?2011, Y.S.Park |
//|                                                    http://yspark |
//+------------------------------------------------------------------+
#property copyright "Copyright ?2011, Y.S.Park."
#property link      "http://yspark"
#include <stdlib.mqh>
#include <WinUser32.mqh>

//+------------------------------------------------------------------+
//| Input Parameters(External)                                       |
//+------------------------------------------------------------------+

extern int       OrderStrategy = 1;   //

extern double    OrderLot;    //Order lot size
extern double    Lots = 0.1;    //Normal lot size
extern double    MnLots = 0.01;    //Minimum lot size
extern int       MaxOrders = 2;    //Maximun Order Number

extern double       Stoplosses = 10;     //Stop Loss setting
extern double       TakeProfits = 45;      //Take Profit Setting

extern double       TrailingStop = 15;      //trailing stop

extern bool RiskMM=true;   //սǽ Minimum lot size, ͽ Lots ȯ

extern int       Magic=2011;     //Magic Number
extern int       Slippage = 4;     //Slippage setting



//+------------------------------------------------------------------+
//| Input Parameters(Internal)                                       |
//+------------------------------------------------------------------+

int       digit=0;
datetime  PreviousBarTime1;
datetime  PreviousBarTime2;

bool isTrade = false;


//+------------------------------------------------------------------+
//| First Calc Function                                              |
//+------------------------------------------------------------------+
void FirstCalc() {
if ( MarketInfo(Symbol(),MODE_DIGITS) == 5 ) digit = 10;
if ( MarketInfo(Symbol(),MODE_DIGITS) == 4 ) digit = 1;
}

//+------------------------------------------------------------------+
//| Deinitialization                                                 |
//+------------------------------------------------------------------+ 

/*int deinit()
{
  return(0);
}*/

//+------------------------------------------------------------------+
//| Start Function                                                   |
//+------------------------------------------------------------------+ 

int start()
{
   FirstCalc();

   if(TrailingStop>0) MoveTrailingStop();


//+------------------------------------------------------------------+
//| Risk Management                                                  |
//+------------------------------------------------------------------+

   if(RiskMM) CheckLastOrderResult();

//+------------------------------------------------------------------+
//| Main Signal                                                      |
//+------------------------------------------------------------------+ 
   bool SignalBuy = false;
   bool SignalSell = false;
   int Signal=Signal_Generator();

//+------------------------------------------------------------------+
//| Buy Condition                                                    |
//+------------------------------------------------------------------+     

   if (Signal==1) SignalBuy = true;
   if (SignalBuy==true && NewBarBuy() && ( CountOrders(OP_SELL,Magic) + CountOrders(OP_BUY,Magic) ) < MaxOrders ) BuyOrders();
//+------------------------------------------------------------------+
//| Sell Condition                                                   |
//+------------------------------------------------------------------+

   if (Signal==-1) SignalSell = true;
   if (SignalSell==true && NewBarSell() && ( CountOrders(OP_SELL,Magic) + CountOrders(OP_BUY,Magic) ) < MaxOrders ) SellOrders();

//+------------------------------------------------------------------+
//| CloseBuy Condition                                               |
//+------------------------------------------------------------------+
      
    if (Signal==2)
    {
        CloseBuyOrders();
        
    }

//+------------------------------------------------------------------+
//| CloseSell Condition                                              |
//+------------------------------------------------------------------+

    if (Signal==-2)
    {
        CloseSellOrders();
        
    }

}

//+------------------------------------------------------------------+
//| Buy Order                                                        |
//+------------------------------------------------------------------+

void BuyOrders()
{
    int ticket;
    double SL = Ask - (Stoplosses*digit*Point);
    double TP = Ask + (TakeProfits*digit*Point);

    if(!isTrade) {
		if(AccountFreeMargin() < (1000 * Lots)) {
		Print("   ܰ մϴ. = ", AccountFreeMargin());
		return(0); }
	}

    ticket = OrderSend(Symbol(), OP_BUY, OrderLot, Ask, Slippage, SL, TP, "ż(#" + Magic + ")", Magic, 0, Blue);

    if(ticket > 0) {
		if(OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES)) {
		Print("ż  Ϸ : ", OrderOpenPrice());
		}
	else {
		Print("ż   : ", GetLastError());
		}
	}
}


//+------------------------------------------------------------------+
//| Sell Order                                                       |
//+------------------------------------------------------------------+

void SellOrders()
{
    int tickets;
    double SL = Bid + (Stoplosses*digit*Point);
    double TP = Bid - (TakeProfits*digit*Point);

    if(!isTrade) {
		if(AccountFreeMargin() < (1000 * Lots)) {
		Print("   ܰ մϴ. = ", AccountFreeMargin());
		return(0); }
	}

    tickets = OrderSend(Symbol(), OP_SELL, OrderLot, Bid, Slippage, SL, TP, "ŵ(#" + Magic + ")", Magic, 0, Red);

    if(tickets > 0) {
		if(OrderSelect(tickets, SELECT_BY_TICKET, MODE_TRADES)) {
		Print("ŵ  Ϸ : ", OrderOpenPrice());
		}
	else {
		Print("ŵ   : ", GetLastError());
		}
	}
}


//+------------------------------------------------------------------+
//| Count Orders                                                     |
//+------------------------------------------------------------------+

int CountOrders(int Type,int magicnumber)
{
   int _CountOrd;
   _CountOrd=0;
   for(int i=0;i<OrdersTotal();i++)
   {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()==Symbol())
      {
         if((OrderType()==Type&&(OrderMagicNumber()==magicnumber)||magicnumber==0))_CountOrd++;
      }
   }
   return(_CountOrd);
}

//+------------------------------------------------------------------+
//| Close Buy Order                                                  |
//+------------------------------------------------------------------+

void CloseBuyOrders()
{
  int total=OrdersTotal();

  for (int cnt=total-1;cnt>=0;cnt--)
  {
    OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
    if(OrderMagicNumber()==Magic&&OrderSymbol()==Symbol())
    {
      if(OrderType()==OP_BUY)
      {
        OrderClose(OrderTicket(),OrderLot,Bid,Slippage);
      }
    }
  }
  return(0);
}


//+------------------------------------------------------------------+
//| Close Sell Order                                                 |
//+------------------------------------------------------------------+

void CloseSellOrders()
{
  int total=OrdersTotal();

  for(int cnt=total-1;cnt>=0;cnt--)
  {
    OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
    if(OrderMagicNumber()==Magic&&OrderSymbol()==Symbol())
    {
      if(OrderType()==OP_SELL)
      {
        OrderClose(OrderTicket(),OrderLot,Ask,Slippage);
      }
    }
  }
  return(0);
}

//+------------------------------------------------------------------+
//| Trailing Stop                                                    |
//+------------------------------------------------------------------+

void MoveTrailingStop()
{
   int cnt,totl=OrdersTotal();
   for(cnt=0;cnt<totl;cnt++)
   {
      OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
      if(OrderType()<=OP_SELL&&OrderSymbol()==Symbol()&&OrderMagicNumber()==Magic)
      {
         if(OrderType()==OP_BUY)
         {
            if( TrailingStop>0 && Ask>NormalizeDouble(OrderOpenPrice()+TrailingStop*digit,Digits) )  
            {                 
               if((NormalizeDouble(OrderStopLoss(),Digits)<NormalizeDouble(Ask-digit*TrailingStop,Digits))||(OrderStopLoss()==0))
               {
                  OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Ask-digit*TrailingStop,Digits),NormalizeDouble(OrderTakeProfit()+digit*TrailingStop,Digits),0,Blue);
                  return(0);
               }
            }
         }
         else 
         {
            if(TrailingStop>0 && Bid<NormalizeDouble(OrderOpenPrice()-TrailingStop*digit,Digits))  
            {                 
               if((NormalizeDouble(OrderStopLoss(),Digits)>(NormalizeDouble(Bid+(digit*TrailingStop),Digits)))||(OrderStopLoss()==0))
               {
                  OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Bid+(digit*TrailingStop),Digits),NormalizeDouble(OrderTakeProfit()-digit*TrailingStop,Digits),0,Red);
                  return(0);
               }
            }
         }
      }
   }
}



//+------------------------------------------------------------------+
//| Allow One Action Per Bar                                         |
//+------------------------------------------------------------------+
//  ϶ ϳ  ٷ ν
bool NewBarBuy()
{
   if(PreviousBarTime1<Time[0])
   {
      PreviousBarTime1=Time[0];
      return(true);
   }
   return(false);
}

bool NewBarSell()
{
   if(PreviousBarTime2<Time[0])
   {
      PreviousBarTime2=Time[0];
      return(true);
   }
   return(false);
}


//+------------------------------------------------------------------+
//| Check Last Order Result                                          |
//+------------------------------------------------------------------+

void CheckLastOrderResult()
{
    double profit = 0;
    datetime lastCloseTime = 0;
    int cnt = OrdersHistoryTotal();
    for (int i=0; i < cnt; i++)
    {
        if (!OrderSelect(i, SELECT_BY_POS, MODE_HISTORY)) continue;
        if (OrderSymbol() == Symbol() && lastCloseTime < OrderCloseTime())
        {
            lastCloseTime = OrderCloseTime();
            profit = OrderProfit();
        }
    }
    if (profit < 0&&MnLots>=MarketInfo(Symbol(),MODE_MINLOT)) OrderLot=MnLots;
    if (profit < 0&&MnLots<MarketInfo(Symbol(),MODE_MINLOT)) OrderLot=MarketInfo(Symbol(),MODE_MINLOT);
    if (profit >= 0&&Lots>=MarketInfo(Symbol(),MODE_MINLOT)) OrderLot=Lots;
    if (profit >= 0&&MnLots<MarketInfo(Symbol(),MODE_MINLOT)) OrderLot=MarketInfo(Symbol(),MODE_MINLOT);

   return(0);
}


//+------------------------------------------------------------------+
//| Signal Generator                                                 |
//+------------------------------------------------------------------+

int Signal_Generator()
{

int     ATRange = 10 ;

      double Buy1_1 = iBands(NULL, NULL,60,2.0,0,PRICE_CLOSE,MODE_LOWER,3) > Low[3] && iBands(NULL, NULL,60,2.0,0,PRICE_CLOSE,MODE_LOWER,4) < Low[4] ;
      double Buy1_2 = iATR(0,0,14,0)*10000 > ATRange && (iATR(0,0,14,0) - iATR(0,0,14,1)) > (iATR(0,0,14,1) - iATR(0,0,14,2)) ;
      double Buy1_3 = iBands(NULL, NULL,60,2.0,0,PRICE_CLOSE,MODE_LOWER,2) > iBands(NULL, NULL,20,2.0,0,PRICE_CLOSE,MODE_LOWER,2) && iBands(NULL, NULL,20,2.0,0,PRICE_CLOSE,MODE_LOWER,2) > Low[2] ;
      double Buy1_4 = Close[1] < iBands(NULL, NULL,20,2.0,0,PRICE_CLOSE,MODE_LOWER,1) ;
      double Buy1_5 = iMA(NULL, NULL,20,0,MODE_SMA,PRICE_CLOSE,1) - iMA(NULL, NULL,20,0,MODE_SMA,PRICE_CLOSE,0) < iMA(NULL, NULL,20,0,MODE_SMA,PRICE_CLOSE,2) - iMA(NULL, NULL,20,0,MODE_SMA,PRICE_CLOSE,1) ;
      double Buy1_6 = Low[2] < iLow(0,0,iLowest(NULL,0,MODE_LOW,60,3));

      double Sell1_1 = (iBands(NULL, NULL,60,2.0,0,PRICE_CLOSE,MODE_UPPER,3) < High[3]) && (iBands(NULL, NULL,60,2.0,0,PRICE_CLOSE,MODE_UPPER,4) < High[4]) ;
      double Sell1_2 = iATR(0,0,14,0)*10000 > ATRange && (iATR(0,0,14,0) - iATR(0,0,14,1)) > (iATR(0,0,14,1) - iATR(0,0,14,2)) ;
      double Sell1_3 = iBands(NULL, NULL,20,2.0,0,PRICE_CLOSE,MODE_UPPER,2) < High[2] && iBands(NULL, NULL,20,2.0,0,PRICE_CLOSE,MODE_UPPER,2) > iBands(NULL, NULL,60,2.0,0,PRICE_CLOSE,MODE_UPPER,2) ;
      double Sell1_4 = Close[1] < iBands(NULL, NULL,20,2.0,0,PRICE_CLOSE,MODE_UPPER,1) ;
      double Sell1_5 = (iMA(NULL, NULL,20,0,MODE_SMA,PRICE_CLOSE,0) - iMA(NULL, NULL,20,0,MODE_SMA,PRICE_CLOSE,1)) > (iMA(NULL, NULL,20,0,MODE_SMA,PRICE_CLOSE,1) - iMA(NULL, NULL,20,0,MODE_SMA,PRICE_CLOSE,2)) ;
      double Sell1_6 = High[2] > iHigh(0,0,iHighest(NULL,0,MODE_HIGH,60,3));
      
      double CloseBuy1_1 = iBands(NULL, NULL,60,2.0,0,PRICE_CLOSE,MODE_UPPER,0) > (High[0]+Low[0])/2 ;
      double CloseBuy1_2 = iBands(NULL, NULL,60,2.0,0,PRICE_CLOSE,MODE_UPPER,1) < (High[1]+Low[1])/2 ;

      double CloseSell1_1 = iBands(NULL, NULL,60,2.0,0,PRICE_CLOSE,MODE_LOWER,0) < (High[0]+Low[0])/2 ;
      double CloseSell1_2 = iBands(NULL, NULL,60,2.0,0,PRICE_CLOSE,MODE_LOWER,1) > (High[1]+Low[1])/2 ;

	double diWPR1=iWPR(NULL,1,155,0);
	double diWPR2=iWPR(NULL,5,155,0);
	double diWPR3=iWPR(NULL,15,155,0);
	double diWPR4=iWPR(NULL,1,155,0);
	double diWPR5=iWPR(NULL,1,250,0);
	double diWPR6=iWPR(NULL,1,500,0);
	double diClose25=iClose(NULL,1,0);
	double diMA26=iMA(NULL,1,605,0,MODE_EMA,PRICE_CLOSE,0);
	double diMA27=iMA(NULL,1,700,0,MODE_EMA,PRICE_CLOSE,0);
	double diMA28=iMA(NULL,5,700,0,MODE_EMA,PRICE_CLOSE,0);
	double diMA29=iMA(NULL,15,700,0,MODE_EMA,PRICE_CLOSE,0);
	double diATR64=iATR(NULL,1,600,0);
	double diStochastic81=iStochastic(NULL,5,55,15,3,MODE_EMA,PRICE_CLOSE,MODE_MAIN,0);
	double diStochastic82=iStochastic(NULL,5,55,15,3,MODE_EMA,PRICE_CLOSE,MODE_SIGNAL,0);
	double diStochastic83=iStochastic(NULL,5,100,35,3,MODE_EMA,PRICE_CLOSE,MODE_MAIN,0);
	double diStochastic84=iStochastic(NULL,5,100,35,3,MODE_EMA,PRICE_CLOSE,MODE_SIGNAL,0);
	double diRSI93=iRSI(NULL,1,3,PRICE_CLOSE,0);
      
      int Return;

      switch(OrderStrategy)
         {
         case 0:  break;
         case 1:
                  if( Buy1_1 && Buy1_2 && Buy1_3 && Buy1_4 && Buy1_5 && Buy1_6 )      Return=1;   // Buy Condition
                  if( Sell1_1 && Sell1_2 && Sell1_3 && Sell1_4 && Sell1_5 && Sell1_6 )      Return=-1;  // Sell Condition
                  if( CloseBuy1_1 && CloseBuy1_2 )      Return=2;   // CloseBuy Condition
                  if( CloseSell1_1 && CloseSell1_2 )      Return=-2;   // CloseSell Condition
                  Print("Signal ",OrderStrategy,Return);  
                  break;
         
         case 2:
	if ((diStochastic81>diStochastic82) && (diStochastic83>diStochastic84) && (diWPR1>-25) &&  (diWPR2>-35) && (diWPR3>-50)
   	&& (diWPR4>diWPR5) && (diWPR5>diWPR6)) Return = 2;  //CloseBuy Condition

	if ((diStochastic81<diStochastic82) && (diStochastic83<diStochastic84) && (diWPR1<-75) &&  (diWPR2<-65) && (diWPR3<-50)   
   	&& (diWPR4<diWPR5) && (diWPR5<diWPR6)) Return = -2;  // CloseSell Condition

	if (((diATR64>0.0001)) &&  diRSI93<25 && (diStochastic81<diStochastic82) && (diStochastic83<diStochastic84) 
    	&& (diWPR1<-99.999) && (diMA27 < diClose25) && (diMA28 < diClose25) && (diMA29 < diClose25)) Return = 1;     // Buy Condition

	if ( ((diATR64>0.0001)) &&  diRSI93>75 && (diStochastic81>diStochastic82) && (diStochastic83>diStochastic84) 
    	&& (diWPR1>-0.001) && (diMA27 > diClose25) && (diMA28 > diClose25) && (diMA29 > diClose25) ) Return = -1;    // Sell Condition
	Print("Signal ",OrderStrategy,Return);

        break;
	
	default: Return=0;
	break;
     
         }
         
     
      
}